<template>
  <Row class="manager-note-list">
    <stock-list-page :search-columns="searchColumns"
                     :table-columns="tableColumns"
                     :table-data="tableData"
                     :total-data-amount="totalData"
                     :page-size-options="[30]"
                     @search="getNotesAction">
    </stock-list-page>
  </Row>
</template>

<script>
import StockListPage from '../../../components/StockListPage';
import { columns } from '../../../helpers/list';
import { validators as api } from '../../../configs/request-validator/note';

const actions = {
  async getNotesAction(filter) {
    try {
      const request = {
        userId: null,
        pageAt: filter.pageAt || 1,
        pageSize: filter.pageSize || 30,
      };
      this.$conditionMutator(request, filter);

      const { data: { notes, total } } = await this.$api(api.AccessAllNotesResult, request);
      this.tableData = notes;
      this.totalData = total;
    } catch (error) {
      this.$apiErrorHandler(error);
    }
  },
};

export default {
  name: 'index',
  components: { StockListPage },
  data() {
    return {
      searchColumns: [
        {value: 'id', label: 'ID'},
        {value: 'title', label: 'Title'},
        {value: 'content', label: 'Content'},
        {value: 'user.id', label: 'Author ID'},
        {value: 'user.name', label: 'Author Name'},
        {value: 'user.email', label: 'Author Email'},
      ],
      tableColumns: [
        // columns.selection,
        columns.index,
        columns.id,
        { title: 'Title', key: 'title' },
        {
          title: 'Create At',
          width: 150,
          align: 'center',
          fixed: 'right',
          render: (h, param) => {
            const timestamp = param.row['timestamp'];
            const localeDateString = (new Date(timestamp)).toLocaleDateString();
            return h('span', {}, localeDateString);
          }
        },
        {
          title: 'Actions',
          width: 150,
          align: 'center',
          fixed: 'right',
          render: (h, param) => {
            const vue = this;
            const noteId = param.row['id'];
            return h('div', [
              h('div', {
                  class: 'note-view-btn div-btn inline-block',
                  on: {
                    click: () => {
                      vue.$redirectTo('manager-note-id', { id: noteId.toString() })
                    }
                  }
                },
                [
                  h('Icon', { props: { type: 'md-eye' } })
                ]),
            ]);
          }
        }
      ],
      tableData: undefined,
      totalData: 0,
    };
  },
  methods: {
    ...actions,
  },
  mounted() {
    this.$displayBodyBlock(false);
  },
  async asyncData({ app }) {
    let tableData = undefined;
    let totalData = 0;

    // request
    const noteRequest = {
      userId: null,
      pageAt: 1,
      pageSize: 30,
    };
    app.$conditionMutator(noteRequest, {});

    // invoke api
    try {
      const responseData = await Promise.all([
        app.$api(api.AccessAllNotesResult, noteRequest, undefined, false),
      ]);

      // set vue data
      tableData = responseData[0]['data']['notes'];
      totalData = responseData[0]['data']['total'];
    } catch (error) {
      app.$apiErrorHandler(error);
    }

    return { tableData, totalData };
  }
}
</script>

<style lang="scss">
  @import "../../../assets/css/mixin";

  .manager-note-list {
    .note-view-btn {
      margin-left: 10px;
      @include circle-div-btn(32);
    }
    .note-edit-btn {
      margin-left: 10px;
      @include circle-div-btn(32);
    }
  }
</style>
